# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetPrivatelinkEndpointsServiceServerlessResult',
    'AwaitableGetPrivatelinkEndpointsServiceServerlessResult',
    'get_privatelink_endpoints_service_serverless',
    'get_privatelink_endpoints_service_serverless_output',
]

@pulumi.output_type
class GetPrivatelinkEndpointsServiceServerlessResult:
    """
    A collection of values returned by getPrivatelinkEndpointsServiceServerless.
    """
    def __init__(__self__, id=None, instance_name=None, project_id=None, results=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_name and not isinstance(instance_name, str):
            raise TypeError("Expected argument 'instance_name' to be a str")
        pulumi.set(__self__, "instance_name", instance_name)
        if project_id and not isinstance(project_id, str):
            raise TypeError("Expected argument 'project_id' to be a str")
        pulumi.set(__self__, "project_id", project_id)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceName")
    def instance_name(self) -> str:
        return pulumi.get(self, "instance_name")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> str:
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetPrivatelinkEndpointsServiceServerlessResultResult']:
        """
        Each element in the `result` array is one private serverless endpoint.
        """
        return pulumi.get(self, "results")


class AwaitableGetPrivatelinkEndpointsServiceServerlessResult(GetPrivatelinkEndpointsServiceServerlessResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPrivatelinkEndpointsServiceServerlessResult(
            id=self.id,
            instance_name=self.instance_name,
            project_id=self.project_id,
            results=self.results)


def get_privatelink_endpoints_service_serverless(instance_name: Optional[str] = None,
                                                 project_id: Optional[str] = None,
                                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPrivatelinkEndpointsServiceServerlessResult:
    """
    **WARNING:** This data source is deprecated and will be removed in March 2025. For more datails see Migration Guide: Transition out of Serverless Instances and Shared-tier clusters

    `privatelink_endpoints_service_serverless` describes the list of all Serverless PrivateLink Endpoint Service resource.

    > **NOTE:** Groups and projects are synonymous terms. You may find group_id in the official documentation.

    ## Example with AWS

    ```python
    import pulumi
    import pulumi_mongodbatlas as mongodbatlas

    test_serverless_instance = mongodbatlas.ServerlessInstance("test",
        project_id="<PROJECT_ID>",
        name="test-db",
        provider_settings_backing_provider_name="AWS",
        provider_settings_provider_name="SERVERLESS",
        provider_settings_region_name="US_EAST_1",
        continuous_backup_enabled=True)
    test = mongodbatlas.get_privatelink_endpoints_service_serverless_output(project_id="<PROJECT_ID>",
        instance_name=test_serverless_instance.name)
    test_privatelink_endpoint_serverless = mongodbatlas.PrivatelinkEndpointServerless("test",
        project_id="<PROJECT_ID>",
        instance_name=test_serverless_instance.name,
        provider_name="AWS")
    test_privatelink_endpoint_service_serverless = mongodbatlas.PrivatelinkEndpointServiceServerless("test",
        project_id="<PROJECT_ID>",
        instance_name="test-db",
        endpoint_id=test_privatelink_endpoint_serverless.endpoint_id,
        provider_name="AWS",
        comment="New serverless endpoint")
    ```

    ## Example with AZURE

    ```python
    import pulumi
    import pulumi_mongodbatlas as mongodbatlas

    test_serverless_instance = mongodbatlas.ServerlessInstance("test",
        project_id="<PROJECT_ID>",
        name="test-db",
        provider_settings_backing_provider_name="AZURE",
        provider_settings_provider_name="SERVERLESS",
        provider_settings_region_name="US_EAST",
        continuous_backup_enabled=True)
    test = mongodbatlas.get_privatelink_endpoints_service_serverless_output(project_id="<PROJECT_ID>",
        instance_name=test_serverless_instance.name)
    test_privatelink_endpoint_serverless = mongodbatlas.PrivatelinkEndpointServerless("test",
        project_id="<PROJECT_ID>",
        instance_name=test_serverless_instance.name,
        provider_name="AZURE")
    test_privatelink_endpoint_service_serverless = mongodbatlas.PrivatelinkEndpointServiceServerless("test",
        project_id="<PROJECT_ID>",
        instance_name="test-db",
        endpoint_id=test_privatelink_endpoint_serverless.endpoint_id,
        provider_name="AZURE",
        comment="New serverless endpoint")
    ```


    :param str instance_name: Human-readable label that identifies the serverless instance
    :param str project_id: Unique 24-digit hexadecimal string that identifies the project.
    """
    __args__ = dict()
    __args__['instanceName'] = instance_name
    __args__['projectId'] = project_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('mongodbatlas:index/getPrivatelinkEndpointsServiceServerless:getPrivatelinkEndpointsServiceServerless', __args__, opts=opts, typ=GetPrivatelinkEndpointsServiceServerlessResult).value

    return AwaitableGetPrivatelinkEndpointsServiceServerlessResult(
        id=pulumi.get(__ret__, 'id'),
        instance_name=pulumi.get(__ret__, 'instance_name'),
        project_id=pulumi.get(__ret__, 'project_id'),
        results=pulumi.get(__ret__, 'results'))
def get_privatelink_endpoints_service_serverless_output(instance_name: Optional[pulumi.Input[str]] = None,
                                                        project_id: Optional[pulumi.Input[str]] = None,
                                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetPrivatelinkEndpointsServiceServerlessResult]:
    """
    **WARNING:** This data source is deprecated and will be removed in March 2025. For more datails see Migration Guide: Transition out of Serverless Instances and Shared-tier clusters

    `privatelink_endpoints_service_serverless` describes the list of all Serverless PrivateLink Endpoint Service resource.

    > **NOTE:** Groups and projects are synonymous terms. You may find group_id in the official documentation.

    ## Example with AWS

    ```python
    import pulumi
    import pulumi_mongodbatlas as mongodbatlas

    test_serverless_instance = mongodbatlas.ServerlessInstance("test",
        project_id="<PROJECT_ID>",
        name="test-db",
        provider_settings_backing_provider_name="AWS",
        provider_settings_provider_name="SERVERLESS",
        provider_settings_region_name="US_EAST_1",
        continuous_backup_enabled=True)
    test = mongodbatlas.get_privatelink_endpoints_service_serverless_output(project_id="<PROJECT_ID>",
        instance_name=test_serverless_instance.name)
    test_privatelink_endpoint_serverless = mongodbatlas.PrivatelinkEndpointServerless("test",
        project_id="<PROJECT_ID>",
        instance_name=test_serverless_instance.name,
        provider_name="AWS")
    test_privatelink_endpoint_service_serverless = mongodbatlas.PrivatelinkEndpointServiceServerless("test",
        project_id="<PROJECT_ID>",
        instance_name="test-db",
        endpoint_id=test_privatelink_endpoint_serverless.endpoint_id,
        provider_name="AWS",
        comment="New serverless endpoint")
    ```

    ## Example with AZURE

    ```python
    import pulumi
    import pulumi_mongodbatlas as mongodbatlas

    test_serverless_instance = mongodbatlas.ServerlessInstance("test",
        project_id="<PROJECT_ID>",
        name="test-db",
        provider_settings_backing_provider_name="AZURE",
        provider_settings_provider_name="SERVERLESS",
        provider_settings_region_name="US_EAST",
        continuous_backup_enabled=True)
    test = mongodbatlas.get_privatelink_endpoints_service_serverless_output(project_id="<PROJECT_ID>",
        instance_name=test_serverless_instance.name)
    test_privatelink_endpoint_serverless = mongodbatlas.PrivatelinkEndpointServerless("test",
        project_id="<PROJECT_ID>",
        instance_name=test_serverless_instance.name,
        provider_name="AZURE")
    test_privatelink_endpoint_service_serverless = mongodbatlas.PrivatelinkEndpointServiceServerless("test",
        project_id="<PROJECT_ID>",
        instance_name="test-db",
        endpoint_id=test_privatelink_endpoint_serverless.endpoint_id,
        provider_name="AZURE",
        comment="New serverless endpoint")
    ```


    :param str instance_name: Human-readable label that identifies the serverless instance
    :param str project_id: Unique 24-digit hexadecimal string that identifies the project.
    """
    __args__ = dict()
    __args__['instanceName'] = instance_name
    __args__['projectId'] = project_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('mongodbatlas:index/getPrivatelinkEndpointsServiceServerless:getPrivatelinkEndpointsServiceServerless', __args__, opts=opts, typ=GetPrivatelinkEndpointsServiceServerlessResult)
    return __ret__.apply(lambda __response__: GetPrivatelinkEndpointsServiceServerlessResult(
        id=pulumi.get(__response__, 'id'),
        instance_name=pulumi.get(__response__, 'instance_name'),
        project_id=pulumi.get(__response__, 'project_id'),
        results=pulumi.get(__response__, 'results')))
